package com.github.gkutiel.flip.web;

import java.io.IOException;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;

import org.eclipse.jetty.websocket.WebSocket;

import com.github.gkutiel.flip.utils.Utils;

public abstract class FlipSocket implements WebSocket.OnTextMessage {

	private final Cookie[] cookies;
	protected Connection con;

	public FlipSocket(final HttpServletRequest req) {
		cookies = req.getCookies();
	}

	public final <T> T get(final Key<T> key) {
		return HttpUtils.get(cookies, key);
	}

	@Override
	public void onOpen(final Connection con) {
		this.con = con;
	}

	public final void send(final Object msg) throws IOException {
		con.sendMessage(Utils.Json.toString(msg));
	}

}
